unit ThreadAppMainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, ThreadDemoThreadUnit, ThreadControllerUnit, ExtCtrls,
  StdCtrls;

type
  TThreadAppMain = class(TForm)
    TimerShutDown: TTimer;
    EdtThreadsToCreate: TEdit;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure TimerShutDownTimer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    FThreadController: TThreadController;
  public
    { Public declarations }
  end;

var
  ThreadAppMain: TThreadAppMain;
  AppCounter: Integer;

implementation

{$R *.DFM}

procedure TThreadAppMain.FormCreate(Sender: TObject);
begin
  AppCounter := 0;
  FThreadController := TThreadController.Create;
end;

procedure TThreadAppMain.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  TimerShutDown.Enabled := False;
  Screen.Cursor := crHourGlass;
  FThreadController.Shutdown := True;
  CanClose := FThreadController.ActiveThreads = 0;
  TimerShutDown.Enabled := not CanClose;
end;

procedure TThreadAppMain.TimerShutDownTimer(Sender: TObject);
begin
  Close;
end;

procedure TThreadAppMain.Button1Click(Sender: TObject);
var
  intThreadCount, i: integer;
begin
  intThreadCount := StrToIntDef(edtThreadsToCreate.Text,1);
  for i := 1 to intThreadCount do
    ThreadDemoThread.create(False,FThreadController);
end;

end.
